/* 
 * File:   gff_entry.h
 * Author: Aziz Mithani
 *
* Created on April 7, 2016, 11:39 AM
  */

#ifndef GFF_ENTRY_H
#define	GFF_ENTRY_H

#include <string>
#include <vector>

using namespace std;

class gff_entry {
public:
    gff_entry(string sequence_name, int start, int end, string str_gff_entry);
    gff_entry(vector<string>& entries, string str_gff_entry);
    gff_entry(const gff_entry& old_gff_entry);
    virtual ~gff_entry();
    
    int get_end() const;
    int get_start() const;
    void set_sequence_name(string sequence_name);
    string get_sequence_name() const;
    string get_gff_entry() const;
    string get_feature() const;
    char get_strand() const;
    void set_modified(bool modified);
    bool modified() const;
    void set_valid(bool gff_entry_valid);
    bool valid() const;
    static string header_short();
    string get_feature_id();
    
    void update_start(int start);
    void update_start(int start, bool set_modified_flag);
    void update_end(int end);
    void update_end(int end, bool set_modified_flag);
private:
    string sequence_name;
    string feature;
    int start;
    int end;
    char strand;
    string str_gff_entry;
    bool gff_entry_modified; // flag to indicate if the GFF entry has been modified since creation
    bool gff_entry_valid; // flag to indicate if the GFF entry is valid within the current context

    static const string FEATURE_ID_TAG;


};

#endif	/* GFF_ENTRY_H */

